package  
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.World;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	
	public class GameWorld extends World
	{
		
		// since the maps in DAME can be of different widths, we need
		// a way to keep track of the total length of the level we generate
		private var _totalMapsWidth:Number = 0.0;
		
		
		// create a variable for the player, to use in the update() function
		public var player:Entity;
		
		// pause menu 
		private var _pauseMenu: MenuWorld;
		
		public function GameWorld() 
		{
			super();
			// add the background first, so that it's on the bottom be default
			//add(new BackgroundEntity);
			
			// add the player, and set depth to make sure they are always on top
			player = add(new Player_);
			player.layer = -1;
		
			
			// generate maps until they fill the entire screen
			while (_totalMapsWidth < FP.stage.width + FP.camera.x){
				spawnMap();
			}
			
			// pass current world to the pause mene
			_pauseMenu = new MenuWorld(this);
		}
		
		override public function begin():void 
		{
			super.begin();
				
		}
		
		override public function update():void 
		{
			super.update();
			// just have the camera follow the player
			FP.camera.x = 0.1*FP.camera.x + 0.9*(player.x - 100);
			
			// generate maps until they fill the entire screen
			while (_totalMapsWidth < FP.stage.width + FP.camera.x)
			{
				spawnMap();
			}
			
			// pause the game
			if (Input.pressed(Key.P)) FP.world = _pauseMenu;
		}		
		
		private function spawnMap():void
		{
			// generate a random number, based on the total map layers in XML exported from DAME
			var randomMapNumber:Number = Math.ceil(Math.random() * Assets.LEVEL_TEMPLATES_COUNT);
					
			var mapLayer:String = "Area" + randomMapNumber;
			// notice we are using add() and not create(), which is why we're also setting recycleMaps to false
			var worldMap:TilemapGeneratorEntity = new TilemapGeneratorEntity(Assets.LEVEL_TEMPLATES_XML, Assets.TILES_32, mapLayer, "level", _totalMapsWidth, 0, true, false);
			add(worldMap);
			
			// update the total length of the generated level so far, so we know where to place the next map
			_totalMapsWidth += worldMap.mapLayerWidth;
		}
		
	}

}