package 
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	
	public class Player_ extends Entity 
	{
		protected var sprPlayer:Spritemap = new Spritemap(Assets.PLAYER_SPRITE, 32, 48); 
		
		public var speed:Point = new Point(4, 0);
		private var _collide:Boolean = new Boolean(false);
		private var _ducking:Boolean = new Boolean(false);
		private var _soundJump:Sfx = new Sfx(Assets.SOUND_JUMP);
		FP.volume = 0.2;
		
		public function Player_(x:int=200, y:int=0) 
		{
			sprPlayer.add("stand", [0, 0, 0, 0, 1], 0.02);
			sprPlayer.add("run", [2, 3, 4, 5], 0.1);
			sprPlayer.add("jump", [6], 0);
			sprPlayer.add("duck", [7], 0);
			sprPlayer.add("kick", [5], 0);
			graphic = sprPlayer;
			setHitbox(16, 48,-8, 0);
			type = "player";
			super(x, y);
		}
		
		override public function update():void 
		{
			if (collide("level", x, y + 1))
			{
				_collide = true;
				if ((Input.pressed(Key.UP) || Input.pressed(Key.Z)) && !_ducking)
				{
					speed.y = -Assets.JUMP_SPEED;
					_soundJump.play(0.1);
				}
			}
			else 
			{
				_collide = false;
				speed.y += Assets.GRAVITY;
				
				if (speed.y > Assets.MAX_FALL)
					speed.y = Assets.MAX_FALL;
			}
			
			if (Input.check(Key.RIGHT) && !_ducking)
				speed.x += Assets.ACCEL;
			
			if (Input.check(Key.LEFT) && !_ducking)
				speed.x -= Assets.ACCEL;
			
			speed.x *= Assets.FRICTION;
			
			if (Math.abs(speed.x) < Assets.MIN_SPEED)
				speed.x = 0;
			
			moveBy(speed.x, speed.y, "level", true);
			
			x = Math.max(x, 10);
			
			// ducking
			
			if (Input.check(Key.DOWN))
			{
				_ducking = true;
			}
			else 
			{
				_ducking = false;
			}
			
			updateAnimation();
		}
		
		override public function moveCollideX(e:Entity):Boolean 
		{
			speed.x = 0;
			return true;
		}
		
		override public function moveCollideY(e:Entity):Boolean 
		{
			if (speed.y > 0)
			{
				speed.x = 0;
			}
			
			speed.y = 0;
			return true;
		}
		
		private function updateAnimation():void
		{
			if (speed.x > 1 && speed.y == 0 && _collide == true && _ducking == false)
			{
				sprPlayer.flipped = false;
				sprPlayer.play("run");
			}
			else if (speed.x < -1 && speed.y == 0 && _collide == true && _ducking == false)
			{
				sprPlayer.flipped = true;
				sprPlayer.play("run");
			}
			else if (speed.x < 1 && speed.x >-1 && speed.y == 0 && _collide ==  true && _ducking == false)
			{
				sprPlayer.play("stand");
			}
			
			if ((speed.y > 0 || speed.y < 0) && _ducking == false)
			{
				sprPlayer.play("jump");
			}
			if (_ducking)
			{
				sprPlayer.play("duck");
			}
		}
		
	}
}